#
# spec file for package struts (Version 1.2.4)
#
# Copyright (c) 2009 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# usedforbuild    aaa_base acl ant ant-apache-oro ant-apache-regexp ant-trax antlr attr audit-libs autoconf automake bash bind-libs bind-utils binutils bison brp-check-internal bzip2 coreutils cpio cpp cracklib cvs cyrus-sasl db diffutils e2fsprogs expat-32bit file filesystem fillup findutils flex fontconfig-32bit freetype2-32bit gawk gcc gdbm gdbm-devel gettext gettext-devel glibc glibc-32bit glibc-devel glibc-locale gpm grep groff gzip info insserv jakarta-commons-beanutils jakarta-commons-collections jakarta-commons-digester jakarta-commons-fileupload jakarta-commons-lang jakarta-commons-logging jakarta-commons-validator java-1_4_2-sun java-1_4_2-sun-devel jpackage-utils klogd less libacl libattr libcom_err libgcc libgssapi libmudflap libnscd libstdc++ libtool libxcrypt libxml2 libzio m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl oro pam pam-modules patch perl permissions popt post-build-checks procinfo procps psmisc pwdutils rcs readline regexp rpm sed servletapi4 servletapi5 sgml-skel strace sysvinit tar tcpd texinfo timezone unzip update-alternatives util-linux vim xalan-j2 xerces-j2 xorg-x11-libs-32bit zlib zlib-32bit zlib-devel


Name:           struts
BuildRequires:  ant-apache-oro ant-apache-regexp ant-trax antlr jakarta-commons-fileupload jakarta-commons-lang jakarta-commons-validator java-1_4_2-sun-devel servletapi4 update-alternatives
%define name		struts
%define full_name	jakarta-%{name}
%define version		1.2.4
%define release		2jpp
#%define tomcat3appsdir	%{_localstatedir}/tomcat3/webapps
#%define tomcat4appsdir	%{_localstatedir}/lib/tomcat4/webapps
%define tomcat5appsdir  /srv/www/tomcat5/base/webapps
%define tomcat5ctxdir   %{_sysconfdir}/tomcat5/base/Catalina/localhost
%define section		free
%define webapps		blank documentation example examples tiles-documentation
%define webapplibs commons-beanutils commons-digester commons-fileupload commons-validator oro struts
%define jdkmajorver 1.4
%define legacyver 1.0
Version:        1.2.4
Release:        23.9
Summary:        Web application framework
License:        The Apache Software License
Group:          Development/Libraries/Java
Source0:        %{full_name}-%{version}-src.tar.gz
Source2:        tomcat4-context-allowlinking.xml
Source3:        tomcat5-context-allowlinking.xml
Source4:        InvalidCancelException.java
Source5:        MockMultipartRequestHandler.java
Source6:        TestRequestUtilsPopulate.java
Source7:        ActionDispatcher.java
Patch0:         %{name}-%{version}.build.patch
Patch1:         %{name}-%{version}.build.xml.patch
Patch2:         %{name}-bug-38374-backport-from-1.2.9.patch
Patch3:         %{name}-bug-38534-backport-from-1.2.9.patch
Patch4:         %{name}-bug-38749-backport-from-1.2.9.patch
Patch5:         jakarta-struts-CVE-2008-2025-backport-from-1.2.9.patch
Url:            http://jakarta.apache.org/struts/
Requires:       servlet
Recommends:     jdbc-stdext
Requires:       jakarta-commons-beanutils >= 1.6.1
Requires:       jakarta-commons-digester >= 1.5
Requires:       jakarta-commons-fileupload >= 1.0
Requires:       jakarta-commons-validator >= 1.0.2
Requires:       oro >= 2.0.7
Group:          Development/Libraries/Java
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
Welcome to the Struts Framework! The goal of this project is to provide
an open source framework useful in building web applications with Java
Servlet and JavaServer Pages (JSP) technology. Struts encourages
application architectures based on the Model-View-Controller (MVC)
design paradigm, colloquially known as Model 2 in discussions on
various servlet and JSP related mailing lists. Struts includes the
following primary areas of functionality: A controller servlet that
dispatches requests to appropriate Action classes provided by the
application developer. JSP custom tag libraries, and associated support
in the controller servlet, that assists developers in creating
interactive form-based applications. Utility classes to support XML
parsing, automatic population of JavaBeans properties based on the Java
reflection APIs, and internationalization of prompts and messages.
Struts is part of the Jakarta Project, sponsored by the Apache Software
Foundation.



%debug_package
%package manual
License:        The Apache Software License
Summary:        Maual for struts
Group:          Development/Libraries/Java

%description manual
Welcome to the Struts Framework! The goal of this project is to provide
an open source framework useful in building web applications with Java
Servlet and JavaServer Pages (JSP) technology.

This package contains the manual for Struts.



%package javadoc
License:        The Apache Software License
Summary:        Javadoc for struts
Group:          Development/Libraries/Java

%description javadoc
Welcome to the Struts Framework! The goal of this project is to provide
an open source framework useful in building web applications with Java
Servlet and JavaServer Pages (JSP) technology.

This package contains the javadoc documentation for Struts.



%package webapps-tomcat5
License:        The Apache Software License
Summary:        Sample struts webapps for tomcat5
Group:          Development/Libraries/Java
Requires:       %{name} = %{version}-%{release}
Requires:       tomcat5
PreReq:         /usr/sbin/useradd, /usr/sbin/groupadd

%description webapps-tomcat5
Welcome to the Struts Framework! The goal of this project is to provide
an open source framework useful in building web applications with Java
Servlet and JavaServer Pages (JSP) technology.

This package contains sample webapps built with Struts for the Jakarta
Tomcat web application server.



%prep
rm -rf $RPM_BUILD_ROOT
%setup -n %{full_name}-%{version}-src -q
%patch0
%patch1
%patch2
%patch3
%patch4
%patch5 -p1
cp %{SOURCE4} src/share/org/apache/struts/action/
cp %{SOURCE5} src/test/org/apache/struts/mock/
cp %{SOURCE6} src/test/org/apache/struts/util/
cp %{SOURCE7} src/share/org/apache/struts/actions/
# remove all binary libs
find . -name "*.jar" -exec rm -f {} \;
# XXX: fix this as %%setup instead
#gzip -dc %{SOURCE1}  | tar xf - 

%build
# build the legacy stuff first
#pushd .
#cd struts-legacy-%{legacyver}-src
#export CLASSPATH=$(build-classpath jakarta-commons-logging)
##ant -Djdbc20ext.jar=$(find-jar jdbc-stdext) \
#ant -Djdbc20ext.jar=/usr/lib/java/jre/lib/rt.jar \
#	-Djdk.version=%{jdkmajorver} \
#	dist
#popd
# build struts
mkdir lib
export CLASSPATH=$(build-classpath xml-commons-apis jaxp_parser_impl \
jaxp_transform_impl servlet antlr commons-digester-rss oro)
#jaxp_transform_impl jdbc-stdext servlet)
#ant -Djdbc20ext.jar=$(find-jar jdbc-stdext) \
ant -Djdbc20ext.jar=/usr/lib/java/jre/lib/rt.jar \
	-Dcommons-beanutils.jar=$(build-classpath commons-beanutils) \
	-Dcommons-collections.jar=$(build-classpath commons-collections) \
	-Dcommons-digester.jar=$(build-classpath commons-digester) \
	-Dcommons-fileupload.jar=$(build-classpath commons-fileupload) \
	-Dcommons-lang.jar=$(build-classpath commons-lang) \
	-Dcommons-logging.jar=$(build-classpath commons-logging) \
	-Dcommons-validator.jar=$(build-classpath commons-validator) \
	-Djakarta-oro.jar=$(build-classpath oro) \
	-Dantlr.jar=$(build-classpath antlr) \
	 compile.library compile.webapps compile.javadoc

%install
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 target/library/%{name}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} ${jar/-%{version}/}; done)
# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/documentation/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
rm -rf target/documentation/api
# data
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}
install -m 644 target/library/*.tld $RPM_BUILD_ROOT%{_datadir}/%{name}
install -m 644 target/library/*.dtd $RPM_BUILD_ROOT%{_datadir}/%{name}
## suse: no support for tomcat3. Sorry.
# tomcat 3 webapps
#install -d -m 755 $RPM_BUILD_ROOT%{tomcat3appsdir}
#for webapp in %{webapps}; do
#    cp -pr target/$webapp $RPM_BUILD_ROOT%{tomcat3appsdir}/%{name}-$webapp
#    # tomcat3 doesn't support allowLinking, this might not work
#	# XXX: move to %%post/preun
#	for jar in %{webapplibs}; do
#        (cd $RPM_BUILD_ROOT%{tomcat3appsdir}/%{name}-$webapp/WEB-INF/lib \
#        && ln -sf ../../../../../..%{_javadir}/$jar.jar .)
#	done
#    (cd $RPM_BUILD_ROOT%{tomcat3appsdir}/%{name}-$webapp/WEB-INF \
#    && for tld in ../../../../..%{_datadir}/%{name}/*.tld; do ln -sf $tld `basename $tld`; done)
#done
# suse: no support for tomcat4. sorry.
# tomcat 4 webapps
#install -d -m 755 $RPM_BUILD_ROOT%{tomcat4appsdir}
#for webapp in %{webapps}; do
#    cp -pr target/$webapp $RPM_BUILD_ROOT%{tomcat4appsdir}/%{name}-$webapp
#    cat %{SOURCE2} | sed -e "s/@@@APPNAME@@@/$webapp/g;" > $RPM_BUILD_ROOT%{tomcat4appsdir}/%{name}-$webapp.xml
#	# XXX: move to %%post/preun
#	for jar in %{webapplibs}; do
#        (cd $RPM_BUILD_ROOT%{tomcat4appsdir}/%{name}-$webapp/WEB-INF/lib \
#        && ln -sf ../../../../../../..%{_javadir}/$jar.jar .)
#    done
#    (cd $RPM_BUILD_ROOT%{tomcat4appsdir}/%{name}-$webapp/WEB-INF \
#    && for tld in ../../../../../..%{_datadir}/%{name}/*.tld; do ln -sf $tld `basename $tld`; done)
#done
# tomcat 5 webapps
install -d -m 755 $RPM_BUILD_ROOT%{tomcat5appsdir}
install -d -m 755 $RPM_BUILD_ROOT%{tomcat5ctxdir}
for webapp in %{webapps}; do
    cp -pr target/$webapp $RPM_BUILD_ROOT%{tomcat5appsdir}/%{name}-$webapp
    cat %{SOURCE3} | sed -e "s/@@@APPNAME@@@/$webapp/g;" > $RPM_BUILD_ROOT%{tomcat5ctxdir}/%{name}-$webapp.xml
	# XXX: move to %%post/preun
	for jar in %{webapplibs}; do
        (cd $RPM_BUILD_ROOT%{tomcat5appsdir}/%{name}-$webapp/WEB-INF/lib \
        && ln -sf ../../../../../../../..%{_javadir}/$jar.jar .)
    done
    (cd $RPM_BUILD_ROOT%{tomcat5appsdir}/%{name}-$webapp/WEB-INF \
    && for tld in ../../../../../../..%{_datadir}/%{name}/*.tld; do ln -sf $tld `basename $tld`; done)
done

%pre
/usr/sbin/groupadd -r tomcat 2> /dev/null || :
/usr/sbin/useradd -r -g tomcat -s /bin/bash \
                  -c "Tomcat - Apache Servlet/JSP Engine" \
                  -d %{_datadir}/tomcat5 tomcat 2> /dev/null || :

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc INSTALL README
%{_javadir}/*
%{_datadir}/%{name}
%defattr(-,tomcat,tomcat) 
%dir %attr(-,root,root) /etc/tomcat5
%dir /etc/tomcat5/base
%dir /etc/tomcat5/base/Catalina
%dir %attr(-,root,root) /srv/www/tomcat5
%dir /srv/www/tomcat5/base
%dir /etc/tomcat5/base/Catalina/localhost
%dir /srv/www/tomcat5/base/webapps

%files manual
%defattr(-,root,root)
%doc target/documentation/*.html
%doc target/documentation/*.gif
%doc target/documentation/uml
%doc target/documentation/userGuide
%doc target/documentation/images

%files javadoc
%defattr(-,root,root)
%{_javadocdir}/%{name}-%{version}

%files webapps-tomcat5
%defattr(-,tomcat,tomcat)
%dir %attr(-,root,root) /etc/tomcat5
%dir /etc/tomcat5/base
%dir /etc/tomcat5/base/Catalina
%dir %attr(-,root,root) /srv/www/tomcat5
%dir /srv/www/tomcat5/base
%dir /etc/tomcat5/base/Catalina/localhost
%dir /srv/www/tomcat5/base/webapps
%dir %{tomcat5appsdir}/%{name}-blank
%{tomcat5appsdir}/%{name}-blank/*
%dir %{tomcat5appsdir}/%{name}-documentation
%{tomcat5appsdir}/%{name}-documentation/*
%dir %{tomcat5appsdir}/%{name}-example
%{tomcat5appsdir}/%{name}-example/*
%dir %{tomcat5appsdir}/%{name}-examples
%{tomcat5appsdir}/%{name}-examples/*
%dir %{tomcat5appsdir}/%{name}-tiles-documentation
%{tomcat5appsdir}/%{name}-tiles-documentation/*
%{tomcat5ctxdir}/%{name}-*.xml

%changelog
* Wed Mar 25 2009 - mvyskocil@suse.cz
- properly backported a CVE-2008-2025 fix for 1.2.4
* Wed Dec 10 2008 - mvyskocil@suse.cz
- fixed CVE-2008-2025 (bnc#385273)
* Wed May 24 2006 - dbornkessel@suse.de
- changed hard requirement on jdbc-stdext to 'Recommends', as it is not available on some platforms (s390[x])
  Bug 177909
* Thu Apr 27 2006 - dbornkessel@suse.de
- backported struts security fixes from 1.2.9 -> 1.2.4
  Struts bugs:
  * Bug 38374 - Validation always skipped with Globals.CANCEL_KEY.
  * Bug 38534 - DOS attack, application hack.
  * Bug 38749 - XSS vulnerability in LookupDispatchAction.
  Novell bug: 162429
* Mon Apr 24 2006 - dbornkessel@suse.de
- bug #140311 fix (file list changed)
* Wed Jan 25 2006 - mls@suse.de
- converted neededforbuild to BuildRequires
* Wed Sep 28 2005 - dmueller@suse.de
- add norootforbuild
* Mon Mar 14 2005 - skh@suse.de
- use correct tomcat5 directories for webapps (#63194)
* Tue Feb 22 2005 - skh@suse.de
- update to version 1.2.4
* Sun Sep 05 2004 - skh@suse.de
- Initial package created with version 1.1 (JPackage 1.5)
